unit Ungca32;

interface

uses
	Windows, Messages, SysUtils,
	UnifyArc;

//*LHA.DLL Ver.1.1ƌ݊API*/
function _UnGCA(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
function _UnGCAGetVersion: WORD; stdcall;
function _UnGCAGetRunning: BOOL; stdcall;
{
BOOL  WINAPI _export UnGCAGetBackGroundMode(void);
BOOL  WINAPI _export UnGCASetBackGroundMode(const BOOL bBackGroundMode);
BOOL  WINAPI _export UnGCAGetCursorMode(void);
BOOL  WINAPI _export UnGCASetCursorMode(const BOOL bCursorMode);
WORD  WINAPI _export UnGCAGetCursorInterval(void);
BOOL  WINAPI _export UnGCASetCursorInterval(const WORD wInterval);
}

var
	UnGca: function(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall = _UnGca;
	UnGcaGetVersion: function: Word; stdcall = _UnGcaGetVersion;
	UnGcaGetRunning: function: Bool; stdcall = _UnGcaGetRunning;

//*A[JCoAPI*/
function _UnGCACheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
function _UnGCAGetFileCount(ArcFile: LPCSTR): Integer; stdcall;
function _UnGCAConfigDialog(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall;
function _UnGCAQueryFunctionList(const Func: Integer): BOOL; stdcall;
(* 	gȂ̂Ŏ蔲
WINAPI _export UnGCASetOwnerWindow(const HWND hWnd);
BOOL WINAPI _export UnGCAClearOwnerWindow(void);
BOOL WINAPI _export UnGCASetOwnerWindowEx(HWND hWnd, LPARCHIVERPROC lpArcProc);
BOOL WINAPI _export UnGCAKillOwnerWindowEx(HWND hWnd);
*)

var
	UnGcaCheckArchive: function(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall = _UnGcaCheckArchive;
	UnGcaGetFileCount: function(ArcFile: LPCSTR): Integer; stdcall = _UnGcaGetFileCount;
	UnGcaConfigDialog: function(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall = _UnGcaConfigDialog;
	UnGcaQueryFunctionList: function(const Func: Integer): BOOL; stdcall = _UnGcaQueryFunctionList;

//*OpenArchivenAPI*/
function _UnGCAOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
function _UnGCACloseArchive(Arc: HARC): Integer; stdcall;
function _UnGCAFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _UnGCAFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
(* 蔲
int   WINAPI _export UnGCAGetArcFileName(HARC hArc, LPSTR szBuffer, const int nSize);
DWORD WINAPI _export UnGCAGetArcFileSize(HARC hArc);
DWORD WINAPI _export UnGCAGetArcOriginalSize(HARC hArc);
DWORD WINAPI _export UnGCAGetArcCompressedSize(HARC hArc);
BOOL WINAPI _export UnGCAGetArcFileSizeEx(HARC hArc, ULHA_INT64 *lpLLSize);
BOOL WINAPI _export UnGCAGetArcOriginalSizeEx(HARC hArc, ULHA_INT64 *lpLLSize);
BOOL WINAPI _export UnGCAGetArcCompressedSizeEx(HARC hArc, ULHA_INT64 *lpLLSize);
WORD  WINAPI _export UnGCAGetArcRatio(HARC hArc);
WORD  WINAPI _export UnGCAGetArcDate(HARC hArc);
WORD  WINAPI _export UnGCAGetArcTime(HARC hArc);
BOOL  WINAPI _export UnGCAGetArcWriteTimeEx(HARC hArc, FILETIME *lpftLastWriteTime);
BOOL  WINAPI _export UnGCAGetArcCreateTimeEx(HARC hArc, FILETIME *lpftCreationTime);
BOOL  WINAPI _export UnGCAGetArcAccessTimeEx(HARC hArc, FILETIME *lpftLastAccessTime);
UINT  WINAPI _export UnGCAGetArcOSType(HARC hArc);
*)
(* RgAEg
int WINAPI _export UnGCAIsSFXFile(HARC hArc);
*)
(* 蔲
int   WINAPI _export UnGCAGetFileName(HARC hArc, LPSTR szBuffer, const int nSize);
int   WINAPI _export UnGCAGetMethod(HARC hArc, LPSTR szBuffer, const int nSize);
DWORD WINAPI _export UnGCAGetOriginalSize(HARC hArc);
DWORD WINAPI _export UnGCAGetCompressedSize(HARC hArc);

WORD  WINAPI _export UnGCAGetRatio(HARC hArc);
WORD  WINAPI _export UnGCAGetDate(HARC hArc);
WORD  WINAPI _export UnGCAGetTime(HARC hArc);
BOOL WINAPI _export UnGCAGetOriginalSizeEx(HARC hArc, ULHA_INT64 *lpLLSize);
BOOL WINAPI _export UnGCAGetCompressedSizeEx(HARC hArc, ULHA_INT64 *lpLLSize);
DWORD WINAPI _export UnGCAGetWriteTime(HARC hArc);
*)
function _UnGCAGetWriteTimeEx(Arc: HARC; var LastWriteTime: TFILETIME): BOOL; stdcall;
(* 蔲
DWORD WINAPI _export UnGCAGetCRC(HARC hArc);
*)
function _UnGCAGetAttribute(Arc: HARC): Integer; stdcall;
(* 蔲
UINT  WINAPI _export UnGCAGetOSType(HARC hArc);
*)
var
	UnGCAOpenArchive: function(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall = _UnGcaOpenArchive;
	UnGCACloseArchive: function(Arc: HARC): Integer; stdcall = _UnGcaCloseArchive;
	UnGCAFindFirst: function(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _UnGcaFindFirst;
	UnGCAFindNext: function(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _UngcaFindNext;
	UnGCAGetWriteTimeEx: function(Arc: HARC; var LastWriteTime: TFILETIME): BOOL; stdcall = _UnGCAGetWriteTimeEx;
	UnGCAGetAttribute: function(Arc: HARC): Integer; stdcall = _UnGCAGetAttribute;

//*UNLHA32.DLLƎAPI*/
function _UnGCAGetSubVersion: WORD; stdcall;
function _UnGCAExtractMem(const Wnd: HWND; CmdLine: LPCSTR; Buffer: PBYTE; const Size: DWORD; Time: PLONGINT; Attr: PWORD; WriteSize: LPDWORD): Integer; stdcall;
var
	UnGCAGetSubVersion: function: WORD; stdcall = _UnGCAGetSubVersion;
	UnGCAExtractMem: function(const Wnd: HWND; CmdLine: LPCSTR; Buffer: PBYTE; const Size: DWORD; Time: PLONGINT; Attr: PWORD; WriteSize: LPDWORD): Integer; stdcall = _UnGCAExtractMem;

//#### Delphi ####

type
	EUnGcaError = class(EArchiverError);

const
	Ungca32Dll = 'ungca32.dll';

function UnGcaEnabled: Boolean;

implementation

type
	EError = EUnGcaError;

const
	ArchiverDll = Ungca32Dll;

var
	Module: THandle;

function GetProcAddress(ProcName: PChar): Pointer;
begin
	if Module = 0 then
	begin
		Module:= SafeLoadLibrary(ArchiverDll);
		if Module = 0 then
			raise EError.CreateFmt(SFaultLoad, [ArchiverDll]);
	end;
	Result := Windows.GetProcAddress(Module, ProcName);
	if Result = nil then
		raise EError.CreateFmt(SNoExistProc, [ArchiverDll, ProcName]);
end;

function UnGcaEnabled: Boolean;
begin
	if Module = 0 then
		Module := SafeLoadLibrary(ArchiverDll);

	Result := Module <> 0;
end;

function _UnGCA(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
begin
	@UnGca := GetProcAddress('UnGCA');
	Result := UnGca(Wnd, CmdLine, Output, Size)
end;

function _UnGCAGetVersion: WORD; stdcall;
begin
	@UnGcaGetVersion := GetProcAddress('UnGCAGetVersion');
	Result := UnGcaGetVersion
end;

function _UnGCAGetRunning: BOOL; stdcall;
begin
	@UnGCAGetRunning := GetProcAddress('UnGCAGetRunning');
	Result := UnGcaGetRunning
end;

function _UnGCACheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
begin
	@UnGCACheckArchive := GetProcAddress('UnGCACheckArchive');
	Result := UnGcaCheckArchive(FileName, Mode)
end;

function _UnGCAGetFileCount(ArcFile: LPCSTR): Integer; stdcall;
begin
	@UnGcaGetFileCount := GetProcAddress('UnGCAGetFileCount');
	Result := UnGcaGetFileCount(ArcFile)
end;

function _UnGCAConfigDialog(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall;
begin
	@UnGcaConfigDialog := GetProcAddress('UnGCAConfigDialog');
	Result := UnGcaConfigDialog(Wnd, OptionBuffer, Mode)
end;

function _UnGCAQueryFunctionList(const Func: Integer): BOOL; stdcall;
begin
	@UnGcaQueryFunctionList := GetProcAddress('UnGCAQueryFunctionList');
	Result := UnGcaQueryFunctionList(Func)
end;

function _UnGCAOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
begin
	@UnGCAOpenArchive := GetProcAddress('UnGCAOpenArchive');
	Result := UnGCAOpenArchive(Wnd, FileName, Mode)
end;

function _UnGCACloseArchive(Arc: HARC): Integer; stdcall;
begin
	@UnGCACloseArchive := GetProcAddress('UnGCACloseArchive');
	Result := UnGCACloseArchive(Arc)
end;

function _UnGCAFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnGCAFindFirst := GetProcAddress('UnGCAFindFirst');
	Result := UnGCAFindFirst(Arc, WildName, SubInfo)
end;

function _UnGCAFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnGCAFindNext := GetProcAddress('UnGCAFindNext');
	Result := UnGCAFindNext(Arc, SubInfo)
end;

function _UnGCAGetWriteTimeEx(Arc: HARC; var LastWriteTime: TFILETIME): BOOL; stdcall;
begin
	@UnGCAGetWriteTimeEx := GetProcAddress('UnGCAGetWriteTimeEx');
	Result := UnGCAGetWriteTimeEx(Arc, LastWriteTime)
end;

function _UnGCAGetAttribute(Arc: HARC): Integer; stdcall;
begin
	@UnGCAGetAttribute := GetProcAddress('UnGCAGetAttribute');
	Result := UnGCAGetAttribute(Arc)
end;

function _UnGCAGetSubVersion: WORD; stdcall;
begin
	@UnGcaCheckArchive := GetProcAddress('UnGCAGetSubVersion');
	Result := UnGCAGetSubVersion
end;

function _UnGCAExtractMem(const Wnd: HWND; CmdLine: LPCSTR; Buffer: PBYTE; const Size: DWORD; Time: PLONGINT; Attr: PWORD; WriteSize: LPDWORD): Integer; stdcall;
begin
	@UnGCAExtractMem := GetProcAddress('UnGCAExtractMem');
	Result := UnGCAExtractMem(Wnd, CmdLine, Buffer, Size, Time, Attr, WriteSize)
end;

initialization

finalization

	if Module <> 0 then FreeLibrary(Module)

end.
